<?php

namespace Drp\LdapAuthentication;

/**
 * Interface LdapConnector
 * @package Drp\LdapAuthentication
 */
interface LdapConnector
{

    /**
     * Authenticate a user using the current Ldap connector
     * @param $username
     * @param $password
     * @param bool|false $preventRebind
     * @return mixed
     */
    public function authenticate($username, $password, $preventRebind = false);

    /**
     * Return the authenticated user
     * @return mixed
     */
    public function user();

    /**
     * Connect to the LDAP provider using the current configuration
     * @return mixed
     */
    public function connect();

}